<?php
if (!isset($view))
{
    $view = 'default';
}
?>

<?php if ($view == 'default' || $view == 'focused'): ?>

    <div id="alertBox" class="alert danger hidden" role="alert"></div>

    <?php if ($view == 'default'): ?>
        <h1>Resultater</h1>
        <p>Denne siden oppdateres automagisk.</p>
        <span class="float-right">[&nbsp;<a class="info" href="?view=focused" target="_blank">Fokusert visning</a>&nbsp;]</span>
        <span class="float-right">[&nbsp;<a class="info" href="?view=summary">Sammendrag</a>&nbsp;]&nbsp;</span>
        <br>
    <?php endif; ?>

    <noscript>
    Denne siden krever JavaScript
    </noscript>

    <div id="rankingTable">
    Laster inn...
    </div>

    <style>
    .b {
        animation: coolFlash 1s;
    }

    @keyframes coolFlash {
    from { background: lightgreen; }
    }
    </style>

    <script src="<?=$this->config['root_url']?>static/js/ResultService.js"></script>
    <script>
        document.addEventListener('DOMContentLoaded', () => {

            alertBox     = document.getElementById("alertBox");
            rankingTable = document.getElementById("rankingTable");

            new ResultService(alertBox, rankingTable, '<?=$this->config['root_url']?>api/race/results.php?h=');
        });
    </script>

<?php endif; ?>

<?php if ($view == 'summary'): ?>

    <h1>Sammendrag</h1>
    <span class="float-right">[&nbsp;<a class="danger" href="?">Tilbake til resultater</a>&nbsp;]&nbsp;</span>
    <br>

    <table>
        <tr>
            <th>#</th>
            <th>Lag</th>
            <th>Bedrift</th>
            <th>Runder</th>
            <th>Bestetid</th>
        </tr>
        <?php $i = 1; foreach ($teams as $team): ?>
        <tr>
            <td><?=$i++; $i?></td>
            <td><?=htmlspecialchars($team->name)?></td>
            <td><?=htmlspecialchars($team->company)?></td>
            <td><?=htmlspecialchars($team->rounds)?></td>
            <td><?=htmlspecialchars($team->best_time)?></td>
        </tr>
        <?php endforeach; ?>
    </table>

<?php endif; ?>